import 'package:nui_core/data/nui_ent.dart';
import 'nui_condition_matrix.dart';

class NUIConditionKeyMap extends NUIEnt<NUIConditionKeyMap>{
  NUIConditionKeyMap.empty();
  String key;
  NUIConditionMatrix matrix = NUIConditionMatrix.empty();

  @override
  NUIEntMapper<NUIConditionKeyMap> mapper() => NUIConditionKeyMapEnt();
}

class NUIConditionKeyMapEnt extends NUIEntMapper<NUIConditionKeyMap>{
  @override
  String entityName() => "NUIConditionKeyMap";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIConditionKeyMap>(name: "key", type: NUIEntType.STRING, setter: (data, value) => data.key = value, getter: (data) => data.key),
      NUIEntField<NUIConditionKeyMap>(name: "matrix", type: NUIEntType.OBJECT, setter: (data, value) => data.matrix = asObject(NUIConditionMatrixEnt(), value), getter: (data) => data.matrix),
    ];
  }

  @override
  NUIConditionKeyMap newInstance() => NUIConditionKeyMap.empty();
}