import 'package:nui_core/data/nui_ent.dart';
import 'package:nui_config_logic/nui_config_logic.dart';
import 'nui_condition_combination.dart';
import 'nui_condition_value.dart';

class NUIConditionMatrix extends NUIEnt<NUIConditionMatrix>{
  NUIConditionMatrix.empty();

  String defaultVal;
  NUIConditionValue defaultValRaw;
  List<String> defaultValues = List();
  List<NUIConditionValue> defaultValuesRaw = List();
  List<NUIConditionCombination> logics;

  NUIConditionValue getDefault() {
    defaultValRaw = NUIConditionValue.fromRawSingle(raw: defaultVal, value: defaultValRaw);
    defaultValRaw.setValuesRaw(NUIConditionValue.fromRawList(valuesRaw: defaultValues, values: defaultValuesRaw, isValueKey: true));
    return this.defaultValRaw;
  }

  void setDefault(NUIConditionValue var1) {
    this.defaultValRaw = var1;
  }

  NUIConditionValue getConditionResult(Map map, NUIConfigLogic mapper) {
    defaultValRaw = NUIConditionValue.fromRawSingle(raw: defaultVal, value: defaultValRaw);
    List<NUIConditionCombination> list = this.logics != null ? this.logics : List();

    for(NUIConditionCombination c in list){
      if(c.compare(map, mapper) && c.getResultRaw() != null){
        //default = con.result
        return c.getResultRaw();
      }
    }
    return getDefault();
  }

  @override
  NUIEntMapper<NUIConditionMatrix> mapper() => NUIConditionMatrixEnt();
}


class NUIConditionMatrixEnt extends NUIEntMapper<NUIConditionMatrix>{
  @override
  String entityName() => "NUIConditionMatrix";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIConditionMatrix>(name: "defaultVal", type: NUIEntType.STRING, setter: (data, value) => data.defaultVal = value, getter: (data) => data.defaultVal),
      NUIEntField<NUIConditionMatrix>(name: "defaultValRaw", type: NUIEntType.OBJECT, setter: (data, value) => data.defaultValRaw = asObject(NUIConditionValueEnt(), value), getter: (data) => data.defaultValRaw),
      NUIEntField<NUIConditionMatrix>(name: "defaultValues", type: NUIEntType.LIST_STRING, setter: (data, value) => data.defaultValues = asList<String>(value), getter: (data) => data.defaultValues),
      NUIEntField<NUIConditionMatrix>(name: "defaultValuesRaw", type: NUIEntType.LIST_OBJECT, setter: (data, value) => data.defaultValuesRaw = asListOfObjects(NUIConditionValueEnt(), value), getter: (data) => data.defaultValuesRaw),
      NUIEntField<NUIConditionMatrix>(name: "logics", type: NUIEntType.LIST_OBJECT, setter: (data, value) => data.logics = asListOfObjects(NUIConditionCombinationEnt(), value), getter: (data) => data.logics),
    ];
  }

  @override
  NUIConditionMatrix newInstance() => NUIConditionMatrix.empty();
}