import 'package:nui_core/nui_core.dart';
import 'package:nui_config_logic/condition/nui_condition_key_map.dart';
import 'package:nui_config_logic/condition/nui_condition_matrix.dart';

class NUIConditionKeyMapList extends NUIEnt<NUIConditionKeyMapList>{
  NUIConditionKeyMapList.empty();
  List<NUIConditionKeyMap> matrixContent = List();

  NUIConditionMatrix getConditionMapping(String key){
    for(NUIConditionKeyMap m in matrixContent){
      if(match(key, m.key)){
        return m.matrix;
      }
    }
    return null;
  }

  List<String> getAllKeys() {
    List<String> allKeys = List();
    for(NUIConditionKeyMap m in matrixContent){
      allKeys.add(m.key);
    }
    return allKeys;
  }

  @override
  NUIEntMapper<NUIConditionKeyMapList> mapper() => NUIConditionKeyMapListEnt();
}

class NUIConditionKeyMapListEnt extends NUIEntMapper<NUIConditionKeyMapList>{
  @override
  String entityName() => "NUIConditionKeyMapList";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIConditionKeyMapList>(name: "matrixContent", type: NUIEntType.LIST_OBJECT, setter: (data, value) => data.matrixContent = asListOfObjects(NUIConditionKeyMapEnt(), value), getter: (data) => data.matrixContent),
    ];
  }

  @override
  NUIConditionKeyMapList newInstance() =>NUIConditionKeyMapList.empty();
}