import 'package:nui_core/data/nui_ent.dart';
import 'package:nui_config_logic/condition/nui_condition_value.dart';

class NUIMapValue extends NUIEnt<NUIMapValue>{
  NUIMapValue.empty();
  NUIMapValue({this.key, this.value, this.id, NUIConditionValue valueRaw}){
    this._valueRaw = valueRaw;
  }

  String key;
  String value;
  NUIConditionValue _valueRaw;
  String id;

  NUIConditionValue getValueRaw() {
    _valueRaw = NUIConditionValue.fromRawSingle(raw: value, value: _valueRaw);
    return _valueRaw;
  }

  void setValueRaw(NUIConditionValue valueRaw) {
    this._valueRaw = valueRaw;
  }

  @override
  NUIEntMapper<NUIMapValue> mapper() => NUIMapValueEnt();
}

class NUIMapValueEnt extends NUIEntMapper<NUIMapValue>{
  @override
  String entityName() => "NUIMapValue";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIMapValue>(name: "key", type: NUIEntType.STRING, setter: (data, value) => data.key = value, getter: (data) => data.key),
      NUIEntField<NUIMapValue>(name: "value", type: NUIEntType.STRING, setter: (data, value) => data.value = value, getter: (data) => data.value),
      NUIEntField<NUIMapValue>(name: "id", type: NUIEntType.STRING, setter: (data, value) => data.id = value, getter: (data) => data.id),
      NUIEntField<NUIMapValue>(name: "valueRaw", type: NUIEntType.OBJECT, setter: (data, value) => data._valueRaw = asObject(NUIConditionValueEnt(), value), getter: (data) => data._valueRaw),
    ];
  }

  @override
  NUIMapValue newInstance() => NUIMapValue.empty();
}