import 'package:nui_core/data/nui_ent.dart';
import 'package:nui_config_logic/condition/nui_condition_value.dart';
import 'nui_map_value.dart';

class NUIValueMapList extends NUIEnt<NUIValueMapList>{
  NUIValueMapList.empty();
  List<NUIMapValue> values = List();

  Map<String, NUIConditionValue> listToMap(){
    Map<String, NUIConditionValue> map = Map();

    for(NUIMapValue v in (values != null ? values : List<NUIMapValue>())){
      map[v.key] = v.getValueRaw();
    }
    return map;
  }

  @override
  NUIEntMapper<NUIValueMapList> mapper() => NUIValueMapListEnt();
}

class NUIValueMapListEnt extends NUIEntMapper<NUIValueMapList>{
  @override
  String entityName() => "NUIValueMapList";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIValueMapList>(name: "values", type: NUIEntType.LIST_OBJECT, setter: (data, value) => data.values = asListOfObjects(NUIMapValueEnt(), value), getter: (data) => data.values),
    ];
  }

  @override
  NUIValueMapList newInstance() => NUIValueMapList.empty();
}